// onInit

Content.makeFrontInterface(633, 400);

// store references to the samplers.
const var Sampler1 = Synth.getSampler("Sampler1");
const var Sampler2 = Synth.getSampler("Sampler2");
const var Sampler3 = Synth.getSampler("Sampler3");

// UI references
const var ComboBox1 = Content.getComponent("ComboBox1");
const var boxVals = ComboBox1.getAllProperties(); // just get all properties of the combobox element, for later reference.

// just printing all values of the combobox´s available properties:
for (var i = 0; i < boxVals.length; i++) {
    Console.print("ComboBox1:s element id " + i + ": " + boxVals[i]);
}


// get state of combobox, on init:
const var cboxState = ComboBox1.getValue();

Console.print("Current choice made in combobox: " + cboxState);

// 6 buttons change each others´s states:

const var Button1 = Content.getComponent("Button1");
const var Button2 = Content.getComponent("Button2");
const var Button3 = Content.getComponent("Button3");
const var Button4 = Content.getComponent("Button4");
const var Button5 = Content.getComponent("Button5");
const var Button6 = Content.getComponent("Button6");
const var arr_buttons = [Button1, Button2, Button3, Button4, Button5, Button6];
const var arr_buttons_sw = [
	
	[1, 0, 0, 0, 0, 0], // setting 0 means all but this id in the list gets activated.
	[0, 1, 0, 0, 0, 0], // is... 
	[0, 0, 1, 0, 0, 0], // this... 
	[0, 0, 0, 1, 0, 0], // the... 
	[0, 0, 0, 0, 1, 0], // matrix ??
	[0, 0, 0, 0, 0, 1]  // no, just a multidimensional flip-switch-array :)
];
function onNoteOn()
{
	
}
 function onNoteOff()
{
	
}
 function onController()
{
	
}
 function onTimer()
{
	
}
 function onControl(number, value)
{
	
    if (number == ComboBox1)
    {
        Console.print("ComboBox1: " + value);
        if (value == 1)
        {
            Sampler1.loadSampleMap("Samplemap-1-1");
            Sampler2.loadSampleMap("Samplemap-1-2");
            Sampler3.loadSampleMap("Samplemap-1-3");
        }
        if (value == 2)
        {
            Sampler1.loadSampleMap("Samplemap-2-1");
            Sampler2.loadSampleMap("Samplemap-2-2");
            Sampler3.loadSampleMap("Samplemap-2-3");
        }
        if (value == 3)
        {
            Sampler1.loadSampleMap("Samplemap-3-1");
            Sampler2.loadSampleMap("Samplemap-3-2");
            Sampler3.loadSampleMap("Samplemap-3-3");
        }
    }
    
    
    
    for (var i = 0; i < arr_buttons.length; i++) { // loop through the 6.

        if (number == arr_buttons[i]) { // for any button we click that matches an item in the array list.

            if (value == 1) {

                var btn_nr = arr_buttons.indexOf(number); // store the incoming index in the array.

                for (var j = 0; j < arr_buttons.length; j++) { // loop through the 6.

                    // now setting the elements all in one go to their pre-set values in the arr_buttons_sw array number presets.
                    arr_buttons[j].setValue(arr_buttons_sw[btn_nr][j]);

                }

            } else {

                // we dont want the value to be able to be set to 0, cause that´s not radio-style.
                number.setValue(1); // just set it back to one.

            }
		
        }

    }


}
 